$!
$!	SWITCHES.COM				DCL
$!
$!	Arguments:	P1	Null, or the CSR address (OCTAL)
$!			P2	Null, or the Interrupt VECTOR address (OCTAL) 
$!
$!	This command procedure returns a picture of the settings for
$!	a couple of switchpacks on the INTERLAN NI1010 ETHERnet 
$!	controller.
$!
$!	Mark A. Bell			20-Sep-1983
$!
$ON ERROR THEN $EXIT
$!
$!	Prompt for the VECTOR and CSR addresses if needed
$!
$ TYPE SYS$INPUT


	This command procedure will tell you how to set the switches
	on your INTERLAN NI1010 or NI1010A controller to obtain desired
	Control and Status Register (CSR) and Interrupt Vector settings.

$! INQUIRE/NOPUNC NI1010A "Do you have an NI1010A (No): "
$! IF NI1010A .EQS. "Y" THEN NI1010A = "YES"
$! IF NI1010A .NES. "YES" THEN NI1010A = "NO"
$GET_CSR:
$ IF P1 .EQS. "" THEN INQUIRE/NOPUNC P1 "Desired CSR (Octal): "
$CHECK_CSR:
$ IF (P1 .GT. 777770) .OR. (P1 .LT. 760000) THEN GOTO CSR_BOUNDS_ERR
$ IF F$LOCATE("8",P1) .NE. F$LENGTH(P1)	THEN GOTO CSR_OCTAL_ERROR
$ IF F$LOCATE("9",P1) .NE. F$LENGTH(P1)	THEN GOTO CSR_OCTAL_ERROR
$GET_VEC:
$ IF P2 .EQS. "" THEN INQUIRE/NOPUNC P2 "Desired Interrrupt Vector (Octal): "
$CHECK_VEC:
$ IF (P2 .GT. 774) .OR. (P2 .LT. 100) THEN GOTO VEC_BOUNDS_ERR
$ IF F$LOCATE("8",P2) .NE. F$LENGTH(P2)	THEN GOTO VEC_OCTAL_ERROR
$ IF F$LOCATE("9",P2) .NE. F$LENGTH(P2)	THEN GOTO VEC_OCTAL_ERROR
$ IF P2 .NE. ((P2/10)*10) THEN GOTO BAD_VEC_3RD_DIGIT
$!
$!	Do the CSR - mainly switchpack U22 + 1 bit of U23
$!
$ U22 = ""
$ I = 2
$CSR_LOOP:
$ TEMP = F$EXTRACT(I,1,P1)
$ IF TEMP .GE. 4 THEN U22 = U22+" OFF "
$ IF TEMP .LT. 4 THEN U22 = U22+"  ON "
$ IF (TEMP .EQ. 7) .OR. (TEMP .EQ. 6) .OR. (TEMP .EQ. 2) .OR. (TEMP .EQ. 3) -
  THEN U22 = U22+" OFF "
$ IF (TEMP .EQ. 5) .OR. (TEMP .EQ. 4) .OR. (TEMP .EQ. 1) .OR. (TEMP .EQ. 0) -
  THEN U22 = U22+"  ON "
$!
$!	Only check two of the three bits in the 5th digit of CSR
$!	
$ IF I .EQ. 4 THEN GOTO CHECK_CSR_5TH
$ IF (TEMP .NE. ((TEMP/2)*2)) THEN U22 = U22+" OFF "
$ IF (TEMP .EQ. ((TEMP/2)*2)) THEN U22 = U22+"  ON "
$!
$!	Get next digit and see if done
$!
$ I = I + 1
$ IF I .LE. 4  THEN GOTO CSR_LOOP
$!
$!	Check for legal 5th digit of CSR
$!
$CHECK_CSR_5TH:
$ IF (TEMP .NE. ((TEMP/2)*2)) .AND. (I .EQ. 4) THEN GOTO BAD_CSR_5TH_DIGIT
$!
$!	Now get that stray bit in U23
$!
$ TEMP = F$EXTRACT(1,1,P1)
$ IF TEMP .EQ. 7 THEN U23_BIT_7 = " OFF "
$ IF TEMP .EQ. 6 THEN U23_BIT_7 = "  ON "
$ IF (TEMP .GT. 7) .OR. (TEMP .LT. 6) THEN GOTO BAD_CSR_2ND_DIGIT
$!
$!	Now do VECTOR - essentially U23
$!
$ U23 = ""
$ I = 0
$VEC_LOOP:
$ TEMP = F$EXTRACT(I,1,P2)
$ IF TEMP .GE. 4 THEN U23 = U23+" OFF "
$ IF TEMP .LT. 4 THEN U23 = U23+"  ON "
$ IF (TEMP .EQ. 7) .OR. (TEMP .EQ. 6) .OR. (TEMP .EQ. 2) .OR. (TEMP .EQ. 3) -
  THEN U23 = U23+" OFF "
$ IF (TEMP .EQ. 5) .OR. (TEMP .EQ. 4) .OR. (TEMP .EQ. 1) .OR. (TEMP .EQ. 0) -
  THEN U23 = U23+"  ON "
$ IF (TEMP .NE. ((TEMP/2)*2)) THEN U23 = U23+" OFF "
$ IF (TEMP .EQ. ((TEMP/2)*2)) THEN U23 = U23+"  ON "
$!
$ I = I + 1
$ IF I .LE. 1 THEN GOTO VEC_LOOP
$!
$!	Now add in that stray bit from the CSR
$!
$ U23 = U23 + U23_BIT_7
$!
$!	Also, make sure last bit of U23 is OFF
$!
$ U23 = U23 + " OFF "
$!
$!	Now type out picture of the switch settings
$!
$ TYPE SYS$INPUT


	For your controller to have the correct CSR, and VECTOR
$ WRITE SYS$OUTPUT "		CSR: ",P1,"     VECTOR: ",P2
$ TYPE SYS$INPUT


	You should set switchpack U22 to the following setting:
 switch      1    2    3    4    5    6    7    8  
$ WRITE SYS$OUTPUT	"           ",U22
$ TYPE SYS$INPUT


	And set switchpack U23 to the following setting:
 switch      1    2    3    4    5    6    7    8  
$ WRITE SYS$OUTPUT	"           ",U23
$!
$!	ALL DONE!!!!
$!
$EXIT
$!
$!	Error messages
$!
$BAD_CSR_2ND_DIGIT:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- The second octal digit of the CSR must be	*
*			   either 6 or 7.  That is, the number must	*
*			   be in the range 760000 to 777760.  		*
*									*
*	CONSULT YOUR INTERLAN MANUAL FOR MORE DETAILS			*
*									*
*************************************************************************

$ P1 = ""
$ GOTO GET_CSR
$!
$!
$!
$BAD_CSR_5TH_DIGIT:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- The fifth octal digit of the CSR must be	*
*			   an even number less than 7.  		*
*									*
*	CONSULT YOUR INTERLAN MANUAL FOR MORE DETAILS			*
*									*
*************************************************************************

$ P1 = ""
$ GOTO GET_CSR
$!
$BAD_VEC_3RD_DIGIT:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- The 3rd octal digit of the VECTOR must 	*
*			   be 0.			  		*
*									*
*	CONSULT YOUR INTERLAN MANUAL FOR MORE DETAILS			*
*									*
*************************************************************************

$ P2 = ""
$ GOTO GET_VEC
$!
$CSR_BOUNDS_ERR:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- The CSR must be between the 760000 and 	*
*			   777700 (Octal)				*
*									*
*	CONSULT YOUR INTERLAN MANUAL FOR MORE DETAILS			*
*									*
*************************************************************************

$ P1 = ""
$ GOTO GET_CSR
$!
$VEC_BOUNDS_ERR:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- Illegal Interrupt Vector 			*
*									*
*	CONSULT YOUR INTERLAN MANUAL FOR MORE DETAILS			*
*									*
*************************************************************************

$ P2 = ""
$ GOTO GET_VEC
$!
$CSR_OCTAL_ERROR:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- PLEASE SPECIFY CSR IN OCTAL 			*
*									*
*************************************************************************

$ P1 = ""
$ GOTO GET_CSR
$!
$VEC_OCTAL_ERROR:
$ TYPE SYS$INPUT
 
*************************************************************************
*									*
*	!!! ERROR	- PLEASE SPECIFY VEC IN OCTAL 			*
*									*
*************************************************************************

$ P2 = ""
$ GOTO GET_VEC
