$ !
$ ! Command file to load and startup CHAOSnet
$ !
$ ! The following privs are needed to execute this command procedure
$ SET PROC/PRIV=(SYSNAM,CMKRNL,CMEXEC,DETACH,SETPRV,ALTPRI,PSWAPM)
$ !
$ ! Define logical names for where CHAOS software lives.
$ ! The format is @CHNAMES SYSTEM [<sysdev> [<srcdev> [<objdev>]]]
$ ! See CHNAMES.COM for details.
$ @SYS$MANAGER:CHNAMES SYSTEM 
$ !
$ !
$ ! Define the defaults for the Remote Tape Facility:
$ ! If the name CHAOS$RTAPE_DEFAULTS exists, it has the form
$ !
$ !		"drive/option..."  
$ !
$ ! An option is one of ASSIST, NOASSIST, READ_CHECK, NOREAD_CHECK,
$ ! WRITE_CHECK, or NOWRITE_CHECK.
$ ! The "drive", if present, is the default drive to use if the user does not
$ ! specify one, or if he only specifies a unit number.  If only options are
$ ! present, then there is no default drive and users will have to specify a
$ ! drive with each use of the Remote Tape Facility.
$ DEFINE/SYSTEM CHAOS$RTAPE_DEFAULTS "_MTA0:/NOASSIST/READ_CHECK/WRITE_CHECK" 
$ !
$ !	Load up the pseudo devices used to communicate
$ !	with the NCP and the pseudo terminals
$ !
$ @SYS$MANAGER:CHLOADCH.COM
$ @SYS$MANAGER:CHLOADPTY.COM
$ !
$ IF F$GETDVI("XEA0","EXISTS") THEN GOTO NOLOAD_XE0
$ MC SYSGEN
AUTOCONFIGURE ALL/SEL=XEA0
EXIT
$NOLOAD_XE0:
$ DEFINE/SYS CHNCP$DEUNA0 24434
$ DEFINE/SYS XE$0 XEA0:
$ DEFINE/SYS CHNCP$PRIMARY 24434
$ !
$ ! Define site's local time zone characteristics:
$ !
$ ! a) GMT_DSP is displacement west of GMT, in delta time format.
$ DEFINE/SYSTEM GMT_DSP  "0 05:00:00.0" 
$ !
$ ! b) DST_SITE should be ON if this site is currently in a time zone
$ !    which uses daylight savings time.  Otherwise it should be OFF.
$ ! 
$ !*************************************************************************
$ DEFINE/SYSTEM DST_SITE "ON" 
$ !
$ ! Install software that needs it
$ RUN SYS$SYSTEM:INSTALL
CHAOS$RFC:TIMESTAMP/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:MAIL/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:NAME/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMEXEC,WORLD,SYSPRV)
CHAOS$RFC:SEND/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:SINK/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:TELNET/SHARED/OPEN/HEADER_RESIDENT/PRIV=(PHY_IO,GROUP,WORLD)
CHAOS$RFC:FILE/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMKRNL,CMEXEC)
CHAOS$SYSTEM:CHMAIL/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:CFTP/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:QSEND/SHARED/OPEN/HEADER_RESIDENT/PRIV=(SYSPRV,WORLD,OPER)
CHAOS$SYSTEM:STATUS/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:SUPDUP/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:TELUSR/SHARED/OPEN/HEADER_RESIDENT
$!
$!	Now start the NCP process
$!
$ @SYS$MANAGER:CHRESTART
