/* -*- Mode: CC -*- */

/* The software, data, and information contained herein are proprietary to, and comprise
 * valuable trade secrets of, Symbolics, Inc.  They are given in confidence by Symbolics
 * pursuant to a written license agreement, and may be used, copied, transmitted, and stored
 * only in accordance with the terms of such license.
 *
 * Copyright 1984, 1983, 1982, 1981, 1980 Symbolics Inc.  All Rights Reserved.
 *
 * Symbolics, Symbolics 3600, Symbolics 3670, Symbolics 3640, SYMBOLICS-LISP, ZETALISP,
 * MACSYMA, S-GEOMETRY, S-PAINT, and S-RENDER are trademarks of Symbolics, Inc.
 *
 * RESTRICTED RIGHTS LEGEND
 *	Use, duplication, or disclosure by the Government is subject to restrictions
 * as set forth in subdivision (b)(3)(ii) of the Rights in Technical Data and Computer
 * Clause at FAR 52.227-7013.
 *	Symbolics, Inc.
 *	11 Cambridge Center
 *	Cambridge, Massachusetts 02142
 */

/*
 * Attach to another named process (only meaningful if this process
 * was started via a "spawn" command)
 * (stolen from TELUSR.C)
 */

#include <stdio.h>
#include <jpidef.h>

struct VMS_Descriptor {int size; char *ptr;};

#define NDESCRS	20
struct VMS_Descriptor *descr(String)
register char *String;
{
	static struct VMS_Descriptor VMS_Descriptors[NDESCRS];
	static int index = 0;
	register int size = 0;

	if( index==NDESCRS ) index = 0;
	VMS_Descriptors[index].ptr = String;
	while( *String++ ) size++;	/* no nulls inside strings! */
	VMS_Descriptors[index].size = size;
	return(&VMS_Descriptors[index++]);
}

supdup_suspend(father)
{
	int i;
	int status = 1;
	int att_pid = 0;
	char att_name[32];
	long jpi_items = 0;
	static struct {
		short	size;
		short	code;
		char	*buf;
		long	*buf_size;
		} item_list[2];

	if( father )
	{	item_list[0].size = 4;
		item_list[0].code = JPI$_OWNER;
		item_list[0].buf = &att_pid;
		item_list[0].buf_size = 0;
		item_list[1].size = 0;
		item_list[1].code = 0;
		status = sys$getjpi(0,0,0,item_list,0,0,0);
		if( !(status&1) ) goto att_ex;
	}
	else
	{	fprintf(stderr,"Process name: ");
		gets(att_name);
		if( att_name == NULL ) goto att_ex;
		status = sys$getjpi(1,&att_pid,descr(att_name),
				    &jpi_items,0,0,0);
		if( !(status&1) )
		{	for( i = 0; i < strlen(att_name); i++ )
				att_name[i] = toupper(att_name[i]);
			att_pid = 0;
			status = sys$getjpi(0,&att_pid,descr(att_name),
					    &jpi_items,0,0,0);
			if( !(status&1) ) goto att_ex;
		}
	}
	status = lib$attach(&att_pid);
att_ex:	if( !(status&1) )
	{	if( !father ) fprintf(stderr,"Cannot attach to process\n");
		else fprintf(stderr,"There is no superior process to attach to\n");
	}
}

