@comment[this file contains the Chaosnet Software Installation Guide]
@Make[Symanual,form 3]
@String[DocTitle "Symbolics VAX/VMS Chaosnet Software Installation Guide"]
@String[Abbrev="SIG"]
@String[Doc#="990102"]
@String[ReleaseVersion="VAX/VMS Chaosnet Release 5.0"]
@String[DocTradeMarks=""]
@String[SymCopy="1984, 1983"]
@String[Remarks="nil"]
@String[DocTrademarks  "UNIX is a trademark of Bell Laboratories, Inc.
UNIBUS, VAX, and VMS are trademarks of Digital Equipment Corporation.
TENEX is a registered trademark of Bolt Beranek and Newman Inc."]
@include[/dess/doc/bp/frontm.mss]

@Chapter[Introduction]
This software installation guide accompanies @value[ReleaseVersion].

This document sets forth the procedures for installing Symbolics VMS
Chaosnet software, for restarting the Chaosnet, and for relinking and
recompiling the Chaosnet software.  The last chapter presents an
overview of how the VAX/VMS Chaosnet software works.

To install the VMS Chaosnet Software Release 5.0, you must be running
VAX/VMS Release 3.0 or any of the Release 3.0 maintenance updates, such 
as 3.1 or 3.4.  This Chaosnet software cannot be run on later versions
of VAX/VMS, such as Release 4.0 or any release prior to 3.0.  You should
also be running Symbolics Release 5.0.
@index(installation prerequisites)

@Chapter[Procedures for Installing the Symbolics VMS Chaosnet Software] 

This chapter describes the steps used to install Symbolics VMS Chaosnet
software.  It is important that you follow all of these steps in the
order that they are shown.
@index(installation procedures)

In step 5, you can use either an automated method or a manual method to
create and install the Chaosnet startup command procedure.  If this is a
new installation of Chaosnet or if you are not familiar with the VMS
Chaosnet configuration, you should use the automated method.  If you are
familiar with the VMS Chaosnet configuration and you have a specific
reason for doing so, you can use the manual method.  However, do NOT
use the manual method unless you know what you are doing; you can waste
several hours if you do it incorrectly.

The following steps are necessary to install the Chaosnet software:

@begin[enumerate]
Mount and load the installation tape.

Use CHNAMES.COM to define logical names to be used during the
installation.

Test the hardware.

Build the network host table.

Create and install the Chaosnet startup command procedure.

Start up the network control software and verify that the higher level
services work correctly.

Edit SYSTARTUP.COM.

@end[enumerate]

The following paragraphs describe each of these steps in detail.

@begin[enumerate]

@comment(step 1)
@begin[multiple]Mount and load the installation tape.
@index(loading the installation tape)

The first step in installing this software is to mount and load the
installation tape using the VAX/VMS BACKUP utility.  The tape was
written at 1600 BPI using VAX/VMS version 3.4 with the following command:

@Begin[Example]
$ BACKUP CHAOS$DISK:[CHAOS...]   MT:CHAOS50.BCK/DENSITY=1600
@End[Example]

If you already have a Chaosnet kit, and this installation tape is an
update for you, you should use the VMS command RENAME to rename all of
your @r([CHAOS...]) directories to @r([OLDCHAOS...]).  You must be sure
to rename all the @r([CHAOS...]) directories on any of your disks.  Once
the new kit has been installed and has run without problems for a period
of several days, back up the @r([OLDCHAOS]) directories to tape and
delete them from the disks.  
@index([CHAOS] directories)

Do not proceed with this installation if you still have any
@r([CHAOS...]) directory trees.

To load the installation tape, decide on which disk you wish to place
the new @r([CHAOS]) directory and type the following commands.  This
example uses the disk @r(DISK:) and the tape drive @r(MTA2).

@Begin[Example]
$ MOUNT/FOREIGN MTA2 
$ BACKUP MT:CHAOS50.BCK DISK:[*...]*.*.*
@End[Example]

This requires about 7500 blocks of disk space.
@index(disk space requirements)
@end[multiple]

@comment(step 2)
@begin[multiple]Use CHNAMES.COM to define logical names to be used
during the installation.
@index(CHNAMES.COM)
@index(defining Chaosnet logical names)

The command procedure CHNAMES.COM defines the logical names for the VMS
Chaosnet system.  If all the Chaosnet software is on @r[SYS$SYSDEVICE],
you need only to type the following command to define the logical names:

@Begin[Example]
$ @@[CHAOS]CHNAMES SUPERVISOR
@End[Example]

The @t(SUPERVISOR) parameter specifies the type of logical name that is
being defined.

If you placed the software on a disk other than @r[SYS$SYSDEVICE], you
must specify the disk or disks that contain the software.
@r(CHNAMES.COM) accepts up to four parameters for specifying these
disks.  These parameters are documented in @r[CHNAMES.COM].

@End[Multiple]

@comment(step 3)
@begin[multiple]Test the hardware.
@index(testing the hardware)

Before proceeding any further with the installation of the VMS Chaosnet
software, the network hardware interface(s) need(s) to be installed and
tested.  The Chaosnet Release 5.0 software supports only two types of
network interfaces: the Symbolics Chaos hardware interface and the
Interlan Ethernet interface.
@index(Interlan Ethernet interface)
@index(Symbolics Chaos hardware interface)

If your configuration has an Interlan interface that you want the
Chaosnet software to use, make sure that you have read Chapters 1 and 2
of the @i(NI1010 UNIBUS Ethernet Communications Controller Manual) and
have installed the board following the checklist on Page 13.  If you do
not have this manual, contact whomever you received the interface from
for a copy.

If you need to reset the switches on your Interlan board, use the
command procedure @r(SWITCHES.COM), as shown in the following example:

@begin(example)
$ @@[CHAOS.DRIVER.INTERLAN]SWITCHES.COM
@end(example)

After all of your hardware is installed, test it by using the command
procedure @r([CHAOS]TESTHW.COM), as shown in the following example:
@begin[example]
$ @@CHAOS$DISK:[CHAOS]TESTHW
@end[example]

@index(TESTHW.COM)

This test procedure requires the use of another machine (preferably a
Lisp Machine) that is directly connected to the physical network of each
interface on your VAX/VMS system that you wish to test.  For example, if
your system is a VAX with both a Chaos hardware interface and an
Ethernet interface, you must either have two machines at your disposal
or have one other machine that also has interfaces to the same physical
media.

The command procedure @r[TESTHW.COM] first prompts you for some device
configuration data, and then loads the required drivers and I/O
data structures.  It then runs a test program for each interface. The
test programs are @r([CHAOS.DRIVER]PCTESTER) for Chaos hardware and
@r([CHAOS.DRIVER.INTERLAN]NITESTER) for the Interlan interfaces.  These
programs can be run manually without going through @r([TESTHW.COM]) by
determining the 16-bit Chaosnet software address for each interface.
This is done either by polling the board in the case of Chaos hardware
or by prompting you, the user, in the case of Ethernet boards.  These
16-bit addresses should correspond to the octal addresses specified in
your network host tables (see step 4).
@index(running PCTESTER)
@index(running NITESTER)

The next step is to send a STATUS request packet to your VAX from the
other machine(s) you are using.  To do this, use the @b(HOSTAT) command
on the VAX or the @l(hostat) function on the Lisp Machine.  In the
examples shown below, the number 24001 is the Chaosnet address of the
VAX being tested.

The following example shows the @b(HOSTAT) command being used on a VAX:
@begin(example)
$ @@HOSTAT 24001
@end(example)

On a Lisp Machine, you would use the @l(hostat) function:

@begin(example)
@L[(hostat 24001)]
@end(example)

The VAX then looks for the request packet for 60 seconds and answers it
with a packet from a node called "Ethernet-Vax" or "CHAOS-VAX".  If the
other machine sees the response, you then have bidirectional
communication on the subnet to which the interface is attached.  This
means that your hardware and device driver are working correctly.

@b(It is important to note that you should not attempt to bring up the	
network control software until all of your interfaces have successfully
completed their hardware tests.)

After @r[TESTHW.COM] completes successfully, reboot the VAX to clear out
the drivers and I/O database.

@end[multiple]

@comment(step 4)
@begin[multiple]Build the network host table.
@index(building the network host table)

A sample copy of this is included in
@r([CHAOSHOST.TABLESEX]NETHOSTS.TXT).  If you have the host table on
some other machine you can compile a dummy host table with just the
entry for that machine, and then copy the full table to your VAX from
there.  Incidentally, the host table is just like the ITS/TENEX/TOPS20
host table.

@begin(itemize)

@begin{multiple}
The source for this host table is @r([CHAOS.HOST.TABLES]NETHOSTS.TXT). 
You must add the following line at the beginning of this file:
@begin[example]
@t[NET CHAOS,7]
@end[example]
@end{multiple}

@begin{multiple}
Once you have created or edited this file, you should run HTMAKE:

@Begin[Example]
$ RUN CHAOS$SYSTEM:HTMAKE
@End[Example]
@index(running HTMAKE)
This will compile the file into the host database.
@end{multiple}

@begin{multiple}
Next you need to update the terminal location database for the name
server/user. Edit the file @r(CHAOS$SRCDISK:[CHAOS.SERVER]NAMEDAT.MAR)
entering the locations for the various terminal lines, following the
format in the file.  You then run the following command procedures 
to compile the database then link and install it:

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS.SERVER]NAMEDAT COMPILE
$ @@CHAOS$SRCDISK:[CHAOS.SERVER]NAME LINK
$ @@CHAOS$SRCDISK:[CHAOS.SERVER]NAME INSTALL
@End[Example]

@index(updating the terminal location database)

If you do not do this, all terminal locations will be listed as
"Unknown Location".
@end{multiple}
@end(itemize)

@end[multiple]

@comment(step 5)
@begin[multiple]Create and install the Chaosnet startup command
procedure. 
@index(installing the Chaosnet startup command procedure)
You can use either an automated method or a manual method to create and
install the startup command procedure.  If you are installing Chaosnet
for the first time or if you are not familiar with the VMS Chaosnet
configuration, you should use the automated method.  If you are familiar
with the VMS Chaosnet configuration and want to customize the startup
file, you might want to use the manual method instead.

Automated Method:

To use the automated procedure @r[MKCHSTART.COM], you should invoke the
command procedure by entering the following command:

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS]MKCHSTART
@End[Example]

This procedure prompts you for configuration details and provides
instructions for how to proceed.  After this command procedure
completes, go on to step 6.

Manual Method:

If you are already familiar with the VMS Chaosnet configuration,
customize the file @r([CHAOS]CHSTART.COM) for your local system
according to the following directions, and with attention to the
comments in @r[CHSTART.COM] itself.  Do @b[not] try editing previous
versions of @r(CHSTART.COM) unless you are sure you know what you are
doing; you can waste many hours if you do it incorrectly.

The changes to be made are as follows:

@begin[itemize]

@begin{multiple}

If the software is not on @r[SYS$SYSDEVICE], make the following change
in the file @r([CHAOS]CHSTART.COM).  Change the
line @r[$@@SYS$MANAGER:CHNAMES SYSTEM] to show:

@r[$ @@SYS$MANAGER:-
  @*CHNAMES SYSTEM] <disk>

where <disk> is in the form "@r[__DDC@i<n>:]" and is the standard name for
the disk on which the Chaosnet software exists.  Do not place the
software on any disk that will be dismounted.
@end{multiple}

@begin{multiple}
Edit @r[CHSTART.COM] to load the devices PC and NI appropriate for your
site.  Set the values in the @r[SYSGEN CONNECT] statements to their
correct values for your hardware.
@end{multiple}

@begin{multiple}
Modify the values of all of the @r[CHNCP$]xxx logical names according to
the comments.
@end{multiple}

@begin{multiple}
Next edit @r([CHAOS]CHSTART.COM) where it says "Define site's local time
zone characteristics" so that it defines @r[GMT_DSP] and @r[DST_SITE], as
explained there.
@end{multiple}

@begin{multiple}
Edit @r([CHAOS]CHSTART.COM) where it says "Define the defaults for the
Remote Tape Facility" so that it defines @r[CHAOS$RTAPE_DEFAULTS] in the
way appropriate for your site, as explained in the file.
@end{multiple}
@end[itemize]

After editing CHSTART.COM, log into the @r[SYSTEM] account and enter the
following command:

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS]CHINSTALL
@End[Example]

The command procedure asks a sequence of questions to make sure that
everything has been set up correctly.  If you give the wrong answers,
the command procedure tells you what to do; you should start over and
execute it again. 

Whether you used the manual or the automated method, your Chaosnet
software should now be installed.

@end[multiple]

@comment(step 6)
@begin[multiple]Start up the network control software and verify that
higher level services (for example, files and mail) work correctly.
@index(testing the network control software)

Test out the network by invoking @r(SYS$MANAGER:CHSTART.COM) and running
a few of the higher level programs, such as MAIL.
@end[multiple]

@comment(step 7)
@begin[multiple]Edit SYSTARTUP.COM.
@index(editing SYSTARTUP.COM)
Once you are satisfied that the installation has been successful and
that your network is working without any major problems, you can cause
the network to start up automatically after a system reboot.  To do
this, edit the command file @r[SYSTARTUP.COM] to run
@r[@@SYS$MANAGER:CHSTART] and edit any system-wide login file(s) to run
@r[@@SYS$MANAGER:CHLOGIN].  
@end[multiple]
@end[Enumerate]

@Chapter[Restarting the Chaosnet]
@index(restarting the Chaosnet)
The Chaosnet software is implemented with device drivers and a
process called CHAOSNET_NCP.  This is described in more detail in
Chapter 6.  If the CHAOSNET_NCP process goes away, you can do the
following to attempt to start up a new CHAOSNET_NCP process:
@index(CHAOSNET_NCP process)

@Begin[Example]
$ @@SYS$MANAGER:CHRESTART
@End[Example]

@index(CHRESTART.COM)
Do not attempt to use @r[CHSTART.COM] a second time, as that might crash
the VAX/VMS system.

If the process is still there, but it appears to be stuck in some way,
you must first stop it with the VAX/VMS command @r(STOP), and then
follow the procedure described above. 

@Chapter[Modifying The Chaosnet Software]
@index(modifying the Chaosnet software)

@b[NOTE: Please notify the Symbolics Customer Support Department (the
address is available from your local Customer Support or Sales Office)
in writing before attempting to make any patches or modifications to the
VAX/VMS Chaosnet software.  Any modifications or patches that are made
without prior written approval from Symbolics will free Symbolics of any
responsibility to support the network communications for the VAX/VMS
system on which the modified software is being run.]

If you do modify the Chaosnet software, the entire Chaosnet system can
be recompiled by doing the following:
@index(compiling the Chaosnet software)

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS]CHREBUILD COMPILE
@End[Example]

It can be relinked by doing the following:
@index(linking the Chaosnet software)

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS]CHREBUILD LINK
@End[Example]

The resulting files will need to be installed in their proper
directories and libraries, which can be done by typing the following
command:

@Begin[Example]
$ @@CHAOS$SRCDISK:[CHAOS]CHREBUILD INSTALL
@End[Example]

In all cases there should be no error messages of any kind.
The only warning messages should be about lack of a transfer
address for device drivers.

Each component of the system has a similar @r[COM] file for compiling,
linking and installing just that component.  See the command file
@r[REBUILD.COM] for details.
@index(CHREBUILD.COM)

@Chapter[Updating Lisp Machines To Know About You]

After installing Release 5.0 VMS Chaosnet software, use the namespace
database editor to register your VAX in the namespace database, if you
have not already done so.  

@comment(A typical VMS host's namespace entry might
look like:
   try to get screen hardcopy of namespace editor frames while
   editing comet)

If you frequently check to see who is logged in to your VAX/VMS system,
you might find it convenient to assign a number as a
@l(terminal-f-argument), so that a simple key sequence such as
@k(FUNCTION 2 F) will display the names and the locations of VAX/VMS
users.  @l(terminal-f-arguments) are maintained as attributes of your
site's namespace object.  For example, if your site is named NORTH-POLE,
use the following command to edit the site's namespace object and add a
new @l(terminal-f-argument) attribute that associates a number with the
name of your VAX/VMS host:

@begin(example)
(tv:edit-namespace-object :site "NORTH-POLE") 
@end(example)

For more information about the namespace database and the associated
editor, see the @i(Networks and Protocols) document.

@index(namespace database)
@index(@l[tv:edit-namespace-object])

@Chapter[How The Software Works]
@label[softworks]
The Chaosnet protocol for VAX/VMS is implemented with device drivers and a
process called CHAOSNET_NCP, which runs the program
@r[CHAOS$SYSTEM:CHNCP.EXE].  The physical Chaos hardware is handled by
the PC device for which the device driver is @r[PCDRIVER
(CHAOS$SYSTEM:PCDRIVER.EXE)].  The physical Ethernet is handled by the
@r[NI] device for which the device driver is @r[NIDRIVER (CHAOS$SYSTEM:
NIDRIVER.EXE)].  These devices handle the packet input and output to the
actual hardware, but provide no sharing, retransmission, connections, or
any of the other features of the Chaosnet protocol.  Those features are
handled by the @r[NCP] (the VAX/VMS Network Control Program).  The NCP
handles such tasks as the establishment and maintenance of Chaosnet
connections, starting of server processes, and error logging.
@index(CHAOSNET_NCP process)
@index(NIDRIVER)
@index(PCDRIVER)
@index(NCP)

Chaosnet connections are established by opening the @r[CH] device.  The
@r[CH] device is a software device whose sole purpose is to transfer
packets from the user program (or server program) to the @r[NCP], which
is responsible for such tasks as ordering the requests for transmission,
for retransmission, and for flow control.  In the supplied version of
the @r[CHSTART.COM] file, 16 Chaosnet connections can exist in the
system at one time.  Each @r[CHA]@i[n] device corresponds to a single
connection; @r[CHA0:] is used by the @r[NCP].  
@index(@r[CH] device)

It is important that you do not make any changes involving or affecting
the @r[CH] device.

Servers are started by the @r[NCP] in response to any @r[RFC] (Request
for Connection) with no matching LSN waiting for it.  If an @r[RFC] for
@r[FILE] comes in, the image @r[CHAOS$RFC:FILE.EXE] is run.  This runs
with the @r[SETPRV] privilege (and sometimes other privileges), which
should be thrown away by any program needing to protect itself against
arbitrary actions by a user.  For example, there is a complete
@r[LOGIN] system call implemented for the @r[FILE] server, which takes
the password, hashes it according to DEC's algorithm, looks up the user
in the @r[SYSUAF], and sets the user's privileges, quotas, and @r[UIC].
You would want to disable SETPRV in the program when it is not needed
to avoid a user misusing the @r[LOGIN] system.
@index(servers)

Servers will be seen as detached processes with a @r[UIC] of [4,200]
(unless your installation changes the @r[UIC] of the @r[NCP], or unless
the server changes the @r[UIC] itself, as the @r[FILE] server does once
it logs in).  These servers will have a process name of the form
@r[FOO][00A2]. The @r[FOO] will be the contact name which that server is
serving; the number in brackets is a hexadecimal sequence number
to assure uniqueness.

The @r[NCP] does full error logging, and it should remain alive unless
it gets 20 errors in a single hour.  All @r[NCP] errors, server starts,
exits, connection openings and closings (including @r[CLS] texts) are
logged.  In order for this log file to be kept, the @r[UIC] [4,200] will
need a couple hundred blocks of disk quota.  (If that @r[UIC] is
unavailable, another system @r[UIC] can be used if the file
@r[SYS$MANAGER:CHSTART.COM] is edited).

The program @r[CHAOS$SYSTEM:NCPERRFMT.EXE] is responsible for formatting
the error logs that are kept on @r(CHAOS$DISK:[CHAOS.LOG]CHERROR.LOG;*.
If you expect to ask the NCP to close the current version, you must have
the @r[SYSPRV] privilege.  The NCP will prompt for an input file, asking
if the @r[NCP] should close the file if the @r[NCP] has that file open,
and direct the results to @r[SYS$OUTPUT].  Press @r([RETURN]) for the
current file.  Alternatively, this can be run as a foreign command, as
shown in the following example:
@index(NCPERRFMT.EXE)

@Begin[Example]
$ NCPERRFMT:== $CHAOS$SYSTEM:NCPERRFMT
$ NCPERRFMT [CHAOS.LOG]CHERROR.LOG;5 /OUTPUT=CHERROR.LIS
@End[Example]

This creates the output file @r[CHERROR.LIS].  You can also include
the @r[/BEFORE=]<date-time> and the @r[/AFTER=]<date-time> qualifiers to
specify when this will run.

All the sources of programs actually in use (as opposed to under
development or obsolete) are in a state such that they can be compiled
and linked without error. All support libraries should be available from
the @r[CHAOS$LIBRARY:CHAOS.OLB] library.  Most @r[BLISS] code should
only need @r[SYS$LIBRARY:LIB.REQ] and @r[CHAOS$LIBRARY:CHAOS.L32].  Some
more specialized changes may also need @r[NCPDEFS.L32].  Some programs
have their own @r[BLISS] libraries on the same directories.  All sources
are present, along with current object files and @r(EXE) files.  There
is documentation on the library routines in the files
@r([CHAOS.DOC]CHAOS.TXT) and @r[HOSTLIB.TXT].
@index(Chaosnet libraries)

You do not need to place all the software on the same pack.  There are
provisions for placing @r[EXE] files, sources and object libraries on
three different devices.  If you wish to do so, carefully read the
documentation in @r([CHAOS]CHNAMES.COM) to see how to divide up the
software among the devices.  Then change the above line in
@r([CHAOS]CHSTART.COM) to read as follows, as explained in
@r[CHNAMES.COM]:

@Begin[Example]
$ @@SYS$MANAGER:CHNAMES SYSTEM <sysdev> <srcdev> <objdev>
@End[Example]

If you have any problems to report, such as servers going away, you must
include the log file.  The actual log file in @r[BACKUP] format should
be used, not a formatted ASCII version.  In addition, you must include
your @r[NETHOSTS.TXT] file so that the log file can be interpreted.
@index(reporting problems)
@index(system crash dumps)

Also, any system crash reports must include a @r[BACKUP] format tape of
@r[SYSDUMP.DMP], as well as your site configuration file and your
@r[SYS$MANAGER:CHSTART.COM] file if it is different from the one
supplied to you.
