$ TYPE SYS$INPUT

	This is Part 1 of the installation command procedure for 
	the VMS Chaosnet software V5.1 - this part creates the 
	necessary startup command procedure for the net.  Part 2
	is the invocation of the file created here.  More details 
	to come.

	Before proceeding any further, make sure 1) that all hardware
	has been installed and tested (see [CHAOS.DOC]INSTALL.TXT),
	2) that the network host table has been properly configured
	(see [CHAOS.DOC]HOSTLIB.TXT), and 3) that your VAX has been 
	rebooted.

	FYI - this procedure will change your default directory to
	[CHAOS] on the device where you have installed the kit.

$!
$!	First, change to [CHAOS]
$!
$ IF F$LOG("CHAOS$DISK") .NES. "" THEN GOTO CONT_1
$ TYPE SYS$INPUT
***
*** ERROR
***	The device logical names are not defined - you need to run
***	the [CHAOS.CHNAMES] command file (see installation instructions.
***
$ GOTO ERROR_EXIT
$CONT_1:
$ old_dir = f$dir()
$ SET DEFAULT CHAOS$DISK:[CHAOS]
$!
$!	Now open up the file that we're going to write
$!
$ OPEN/WRITE tmp chstart.tmp
$ WT = "WRITE TMP"
$ ON ERROR THEN GOTO ERROR_EXIT
$ ON CONTROL_Y THEN GOTO ERROR_EXIT
$!
$!
$!
$ INQUIR winp "First, are you running from an account with SETPRV?"
$ if winp then goto 10$
$ TYPE SYS$INPUT
***
*** ERROR
***	You need lots of privs to run this, including CMKRNL.
***	Best to have SETPRV.
***
$ GOTO ERROR_EXIT
$10$:
$ WT "$ !"
$ WT "$ ! Command file to load and startup CHAOSnet"
$ WT "$ !"
$ WT "$ ! The following privs are needed to execute this command procedure"
$ WT "$ SET PROC/PRIV=(SYSNAM,CMKRNL,CMEXEC,DETACH,SETPRV,ALTPRI,PSWAPM)"
$!
$!	Now need to add CHNAMES stuff
$!
$ chnmstr = ""
$ TYPE SYS$INPUT

We need to define logical names which point to where the various pieces
of the CHAOS kit reside.

IMPORTANT: make sure you specify all devices in the form "__ddcu:", as
	   you answer the next prompt(s).  See [CHAOS]CHNAMES.COM for
	   more information ragarding this process.

$ INQUIR onedisk "Will all of the CHAOS files be residing on the same disk?"
$ IF (.NOT. onedisk) THEN GOTO MULTI_DISK
$GET_DISK:
$ INQUIR disk "Which disk (<CR> gets default, SYS$SYSDEVICE)?"
$ IF disk .EQS. "" THEN GOTO CONT_2 
$ IF F$EXTRACT(F$LOCATE(":",disk),1,disk) .EQS. ":" THEN GOTO CONT_2
$ TYPE SYS$INPUT
***
*** ERROR
$ WRITE SYS$OUTPUT -
"***	The device name you specified: """,disk,""" is of the wrong "
$ WRITE SYS$OUTPUT -
"***	format.  Try specifying """,disk,":"" instead.  Also if all"  
$ TYPE SYS$INPUT 
***	of your CHAOS files are on the default system device
***	(SYS$SYSDEVICE), then just take the default.
***

$ GOTO GET_DISK
$CONT_2: 
$ chnmstr = disk
$ GOTO ADD_CHNAMES
$MULTI_DISK:
$ INQUIR sysdev "Which disk will the CHAOS executables reside on?"
$ INQUIR srcdev "Which disk will the CHAOS sources reside on?"
$ INQUIR objdev "Which disk will the CHAOS objects reside on?"
$ chnmstr = sysdev+" "+srcdev+" "+objdev
$ADD_CHNAMES:
$ WT "$ !"
$ WT "$ ! Define logical names for where CHAOS software lives."
$ WT "$ ! The format is @CHNAMES SYSTEM [<sysdev> [<srcdev> [<objdev>]]]"
$ WT "$ ! See CHNAMES.COM for details."
$ WT "$ @SYS$MANAGER:CHNAMES SYSTEM ",chnmstr
$ WT "$ !"
$!
$!	Now add tape stuff
$!
$ADD_TAPE:
$ TYPE SYS$INPUT

We will now add the necessary commands to support remote tape access -
read the comments in the file we're producing here (CHSTART.COM) for more 
details.

$ INQUIR mtape "Do you have a tape drive?"
$ IF (.NOT. mtape) THEN GOTO DO_DEVICES 
$ INQUIR mtname -
"If your magtape device is not _MTA0: then specify its name (else <CR>)"
$ IF mtname .EQS. "" THEN mtname = "_MTA0:"
$ WT "$ !"
$ WT "$ ! Define the defaults for the Remote Tape Facility:"
$ WT "$ ! If the name CHAOS$RTAPE_DEFAULTS exists, it has the form"
$ WT "$ !"
$ WT "$ !		""drive/option...""  "
$ WT "$ !"
$ WT "$ ! An option is one of ASSIST, NOASSIST, READ_CHECK, NOREAD_CHECK,"
$ WT "$ ! WRITE_CHECK, or NOWRITE_CHECK."
$ WT "$ ! The ""drive"", if present, is the default drive to use if the user does not"
$ WT "$ ! specify one, or if he only specifies a unit number.  If only options are"
$ WT "$ ! present, then there is no default drive and users will have to specify a"
$ WT "$ ! drive with each use of the Remote Tape Facility."
$ WT "$ DEFINE/SYSTEM CHAOS$RTAPE_DEFAULTS """,mtname,"/NOASSIST/READ_CHECK/WRITE_CHECK"" "
$!
$!	Now add the network devices, starting with the CH pseudo
$!	devices which are used for the inter-process communication 
$!	between user/server processes and the NCP, and the Pseudo
$!	Terminals used for Telnet
$!
$DO_DEVICES:
$ WT "$ !"
$ WT "$ !	Load up the pseudo devices used to communicate"
$ WT "$ !	with the NCP and the pseudo terminals"
$ WT "$ !"
$ WT "$ @SYS$MANAGER:CHLOADCH.COM"
$ WT "$ @SYS$MANAGER:CHLOADPTY.COM"
$ WT "$ !"
$!
$!	Init config code to indicate no hardware interfaces - at the end,
$!	a code of 1 will mean we only have the PC device; a code of 2 will
$!	mean we have only the NI; a code of 3 will mean we have both.  If
$!	we have DEUNA's, then we will add 4 to config for each controller
$!	we want configured.
$!
$ config = 0
$ addr_list = ""
$!
$ TYPE SYS$INPUT

Now it is time to define the hardware interfaces to be used.

$ cpu_type := 'f$getsyi("CPU")'
$ uba_type := "UB0"
$ if cpu_type .eq. 1 then uba_type := "3"
$ if cpu_type .eq. 2 then uba_type := "8"
$ if cpu_type .eq. 3 then uba_type := "UB0"
$ if cpu_type .ge. 1 .and. cpu_type .le. 3 then goto get_pc
$ type sys$input
***
*** WARNING
***	You have a processor which is not an 11/730, /750 or /780!
***

$GET_PC:
$ INQUIR pcp "Do you have a CHAOS hardware interface that you want configured?"
$ IF (.NOT. pcp) THEN GOTO GET_NI
$ TYPE SYS$INPUT

Before proceeding, make sure that the CHAOS interface is installed properly
at a UNIQUE CSR address, with a UNIQUE interrupt vector.

$!
$GET_PC_CSR:
$ INQUIR pccsr "What is the CSR address (in octal) for your CHAOS interface?"
$!
$!	Do some cursory bounds checking
$!
$ if pccsr .gt. 760000 .and. pccsr .lt. 777760 then goto get_pc_vec
$ type sys$input
***
*** ERROR
***	That is not a legal CSR address.
***

$ goto get_pc_csr
$!
$GET_PC_VEC:
$ INQUIR pcvec "What is the interrupt vector (octal) for the CHAOS interface?"
$ if pcvec .ge. 200 .and. pcvec .le. 776 then goto get_pc_ub
$ type sys$input
***
*** ERROR
***	That is not a legal vector address.
***

$ goto get_pc_vec
$GET_PC_UB:
$ INQUIR pcub "Which UNIBUS adapter is the CHAOS interface on <''uba_type'>?"
$ if pcub .eqs. "" then pcub=uba_type
$!
$!	Now add the lines to load and configure the PC device
$!
$LOAD_PC:
$ WT "$ IF F$GETDVI(""PCA0"",""EXISTS"") THEN GOTO NOLOAD_PCA"
$ WT "$ RUN SYS$SYSTEM:SYSGEN"
$ WT "LOAD CHAOS$SYSTEM:PCDRIVER"
$ WT "CONNECT PCA0 /ADAP=",pcub,"/CSR=%O",pccsr,"/VEC=%O",pcvec
$ WT "EXIT"
$ WT "$NOLOAD_PCA:"
$ !
$GET_PC_ADD:
$ INQUIRE pcadd "What is the 16-bit network address (octal) of this interface?"
$ primadd = pcadd
$ addr_list = pcadd+"*"
$ WT "$ DEFINE/SYS CHNCP$CHAOS0 ",pcadd
$!
$!	Update config code
$!
$ config = config + 1
$!
$!	Now deal with the INTERLAN interface
$!
$GET_NI:
$ TYPE SYS$INPUT

$ INQUIR nip "Do you have an INTERLAN hardware interface that you want configured?"
$ IF (.NOT. nip) THEN GOTO GET_DEUNAS
$ TYPE SYS$INPUT

Before proceeding, make sure that the INTERLAN interface is installed
properly at a UNIQUE CSR address, with a UNIQUE interrupt vector.  You
can use the command procedure [CHAOS.DRIVER.INTERLAN]SWITCHES.COM
to assist you in setting the switches on the INTERLAN board.

$!
$GET_NI_CSR:
$ INQUIR nicsr "What is the CSR address (in octal) for your INTERLAN interface?"
$!
$!	Do some cursory bounds checking
$!
$ if nicsr .gt. 760000 .and. nicsr .lt. 777760 then goto get_ni_vec
$ type sys$input
***
*** ERROR
***	That is not a legal CSR address.
***

$ goto get_ni_csr
$!
$GET_NI_VEC:
$ INQUIR nivec "What is the interrupt vector (octal) for the INTERLAN interface?"
$ if nivec .ge. 200 .and. nivec .le. 776 then goto get_ni_ub
$ type sys$input
***
*** ERROR
***	That is not a legal vector address.
***

$ goto get_ni_vec
$GET_NI_UB:
$ INQUIR niub "Which UNIBUS adapter is the INTERLAN interface on <''uba_type'>?"
$ if niub .eqs. "" then niub=uba_type
$!
$!	Now add the lines to load and configure the ni device
$!
$LOAD_NI:
$ WT "$ IF F$GETDVI(""NIA0"",""EXISTS"") THEN GOTO NOLOAD_NIA"
$ WT "$ RUN SYS$SYSTEM:SYSGEN"
$ WT "LOAD CHAOS$SYSTEM:NIDRIVER"
$ WT "CONNECT NIA0 /ADAP=",niub,"/CSR=%O",nicsr,"/VEC=%O",nivec,"/NUMVEC=2"
$ WT "EXIT"
$ WT "$NOLOAD_NIA:"
$!
$GET_NI_ADD:
$ INQUIRE niadd "What is the 16-bit network address (octal) of this interface?"
$ primadd = niadd
$ addr_list = addr_list+niadd+"*"
$ WT "$ DEFINE/SYS CHNCP$INTERLAN0 ",niadd
$!
$!	Update config
$!
$ config = config + 2
$!
$GET_DEUNAS:
$ TYPE SYS$INPUT

$ INQUIRE deuna_p "Do you have any DEUNA's you want configured?"
$ IF (.NOT. deuna_p) THEN GOTO END_OF_DEVICES
$!
$! Make sure the DEUNA's get loaded
$!
$ WT "$ IF F$GETDVI(""XEA0"",""EXISTS"") THEN GOTO NOLOAD_XEA"
$ WT "$ MC SYSGEN"
$ WT "AUTOCONFIGURE ALL/SEL=XE"
$ WT "EXIT"
$ WT "$NOLOAD_XEA:"
$!
$! Now see how many there are, and define CHAOS addresses for them
$!
$ INQUIRE deuna_n "How many DEUNA's do you want configured?"
$ i = 0
$DEUNA_DEF_LOOP:
$ IF (i .GE. deuna_n) THEN GOTO END_OF_DEUNAS
$ WRITE SYS$OUTPUT -
"What is the 16-bit network address (octal) of DEUNA #",i+1,"?"
$ INQUIRE/NOPUNC deuna_add ""
$ WT "$ DEFINE/SYS CHNCP$DEUNA",i," ",deuna_add
$ deuna_add_str[i*7,6]:= 'deuna_add
$ deuna_add_str[(i*7)+6,1]:= *
$ i = i + 1
$ GOTO DEUNA_DEF_LOOP
$!
$END_OF_DEUNAS:
$ config = config + (4*i)
$ primadd = deuna_add
$ addr_list = addr_list+deuna_add_str
$!
$! Done with devices
$!
$END_OF_DEVICES:
$ IF config .GT. 0 THEN GOTO 15$
$ TYPE SYS$INPUT
***
*** ERROR
***	You have not configured any devices.
***
$ GOTO ERROR_EXIT
$!
$!	We do have at least one device
$!
$15$:
$ IF (config .EQ. 3) .OR. (config .GE. 5) THEN GOTO GET_PRIM_ADD
$ WT "$ DEFINE/SYS CHNCP$PRIMARY ",primadd
$ GOTO GET_GMT_DSP
$GET_PRIM_ADD:
$ TYPE SYS$INPUT

You have configured more than one interface - you must now decide which
one will be the primary interface.  The address of the primary interface
should correspond to the first address specified in the network host
table on this and all other systems trying to access this system over the
network.  The host table for this VMS system should be in 

		CHAOS$DISK:[CHAOS.HOST.TABLES]NETHOSTS.TXT

where "CHAOS$DISK" is a logical name for the device which contains the
CHAOS software.

$PROMPT_PRIM_ADD:
$ INQUIR primadd "What is the primary network address (octal) for this system?"
$ IF f$locate(primadd,addr_list) .NE. f$length(addr_list) -
 THEN GOTO PRIM_ADD_OK
$ TYPE SYS$INPUT
***
*** ERROR
***	The primary address must be the same as one of the two addresses
***	you have already specified for your interfaces:
$ IF (config .AND. 1) .NE. 0 THEN -
 WRITE SYS$OUTPUT "***	CHAOS address:    	",pcadd
$ IF (config .AND. 2) .NE. 0 THEN -
 WRITE SYS$OUTPUT "***	INTERLAN address: 	",niadd
$ IF (config .AND. 4) .EQ. 0 THEN GOTO PROMPT_PRIM_ADD
$ i = 1
$ j = 0
$DEUNA_ADDR_LOOP:
$ j = f$locate("*",deuna_add_str)
$ a = f$extract(0,j,deuna_add_str)
$ deuna_add_str = f$extract(j+1,999,deuna_add_str)
$ WRITE SYS$OUTPUT "***	DEUNA #",i," address:	",a
$ IF deuna_add_str .EQS. "" THEN GOTO PROMPT_PRIM_ADD
$ i = i + 1
$ GOTO DEUNA_ADDR_LOOP
$!
$PRIM_ADD_OK:
$ WT "$ DEFINE/SYS CHNCP$PRIMARY ",primadd
$!
$!	See about bridging since we have multiple nodes
$!
$ TYPE SYS$INPUT

One of the features of the VMS CHAOSnet software is that any node attached
to multiple subnets may act as a bridge between the subnets - that is, pass
packets from a node on one subnet to a node on another.  This is accomplished
by the broadcasting of routing packets.

By default, the NCP will broadcast routing packets if the current node is
attached to more than one subnet.  This may not always be desirable, and if
if it not it is necessary to define a logical name at startup time which 
will disable bridging.

$ brdgflag = ""
$ INQUIR bridg "So, do you want to have bridging capability ENABLED?"
$ IF  bridg THEN brdgflag = "!"
$ WT "$ !"
$ WT "$ ! The logical name CHNCP$NOBRIDGE controls whether this node will "
$ WT "$ ! act as a network bridge, forwarding packets from one subnet to "
$ WT "$ ! another. Mainly this equates to the broadcasting of routing table"
$ WT "$ ! info.  By default, any node which has more than one interface (as"
$ WT "$ ! defined by the previous logical names) will broadcast routing table"
$ WT "$ ! packets and act as a bridge.  To overide this function, define the"
$ WT "$ ! logical name CHNCP$NOBRIDGE to RESOLVE TO ANYTHING! This is key - the"
$ WT "$ ! NCP only checks for the existence of the logical name in the logical" 
$ WT "$ ! name table - the actual equivalence string is ignored (e.g., "
$ WT "$ ! a) $DEFINE/SYSTEM CHNCP$NOBRIDGE ""YES"" and"
$ WT "$ ! b) $DEFINE/SYSTEM CHNCP$NOBRIDGE ""NO"" are equivalent to the NCP, and"
$ WT "$ ! either will disable bridging)."
$ WT "$ !"
$ WT "$ ",brdgflag,"DEFINE/SYSTEM CHNCP$NOBRIDGE ""BRIDGING_OFF"" "
$!
$!	Now deal with time-zone displacement from GMT
$!
$GET_GMT_DSP:
$ TYPE SYS$INPUT

Now we need to take care of a few trivial matters.

$ weflag = ""
$ INQUIR wstorest "Are you located West or East of Greenwich, England?"
$ IF F$EXTRACT(0,1,wstorest) .EQS. "E" THEN weflag = "-"
$ INQUIRE gmtdsp "How far are you from Greenwich (in timezones)?"
$ IF F$LENGTH(gmtdsp) .EQ. 1 THEN gmtdsp = "0"+F$STRING(gmtdsp)
$ WT "$ !"
$ WT "$ ! Define site's local time zone characteristics:"
$ WT "$ !"
$ WT "$ ! a) GMT_DSP is displacement west of GMT, in delta time format."
$ WT "$ DEFINE/SYSTEM GMT_DSP  """,weflag,"0 ",gmtdsp,":00:00.0"" "
$!
$!
$!
$ INQUIRE dst "Is daylight savings time applicable to your timezone?"
$ WT "$ !"
$ WT "$ ! b) DST_SITE should be "ON" if this site is currently in a time zone"
$ WT "$ !    which uses daylight savings time.  Otherwise it should be "OFF"."
$ WT "$ ! "
$ WT "$ !*************************************************************************"
$ IF dst THEN $ WT "$ DEFINE/SYSTEM DST_SITE ""ON"" "
$ IF (.NOT. dst) THEN $ WT "$DEFINE/SYSTEM DST_SITE ""OFF"" "
$!
$!
$!	Now add the stuff to install the various images and start the NCP
$!
$ WT "$ !"
$ WT "$ ! Install software that needs it"
$ WT "$ RUN SYS$SYSTEM:INSTALL"
$ WT "CHAOS$RFC:TIMESTAMP/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:MAIL/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:NAME/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMEXEC,WORLD,SYSPRV)"
$ WT "CHAOS$RFC:SEND/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:SINK/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$RFC:TELNET/SHARED/OPEN/HEADER_RESIDENT/PRIV=(PHY_IO,GROUP,WORLD)"
$ WT "CHAOS$RFC:FILE/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMKRNL,CMEXEC)"
$ WT "CHAOS$SYSTEM:CHMAIL/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:CFTP/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:QSEND/SHARED/OPEN/HEADER_RESIDENT/PRIV=(SYSPRV,WORLD,OPER)"
$ WT "CHAOS$SYSTEM:STATUS/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:SUPDUP/SHARED/OPEN/HEADER_RESIDENT"
$ WT "CHAOS$SYSTEM:TELUSR/SHARED/OPEN/HEADER_RESIDENT"
$ WT "$!"
$ WT "$!	Now start the NCP process"
$ WT "$!"
$ WT "$ @SYS$MANAGER:CHRESTART"
$!
$!	Last comments
$!
$ INQUIR winp "Is this VMS version 3.0 or greater?"
$ if winp then goto 25$
$ TYPE SYS$INPUT
***
*** ERROR
*** This software cannot be run on versions of VMS prior to 3.0!
***
$ GOTO ERROR_EXIT
$!
$!	Success - copy all files needed to SYS$MANAGER
$!
$25$:
$30$:
$CLOSE_UP_AND_GO:
$!
$ CLOSE TMP
$ COPY CHAOS$DISK:[CHAOS]CHSTART.TMP SYS$MANAGER:CHSTART.COM
$ COPY CHAOS$DISK:[CHAOS]CHLOGIN.COM SYS$MANAGER:CHLOGIN.COM
$ COPY CHAOS$DISK:[CHAOS]CHNAMES.COM SYS$MANAGER:CHNAMES.COM
$ COPY CHAOS$DISK:[CHAOS]CHRESTART.COM SYS$MANAGER:CHRESTART.COM
$ COPY CHAOS$DISK:[CHAOS]CHLOADCH.COM SYS$MANAGER:CHLOADCH.COM
$ COPY CHAOS$DISK:[CHAOS]CHLOADPTY.COM SYS$MANAGER:CHLOADPTY.COM
$ TYPE SYS$INPUT

So far, so good - you now have a several command files in SYS$MANAGER that
you should peruse as a sanity check:

	CHSTART.COM which is the file we just built - it should bear a
		    resemblance to the one in [CHAOS], which is the
		    example file shipped with the kit.

	CHLOGIN.COM which contains some usefule symbol definitions - you
		    should add the command "$ @SYS$MANAGER:CHLOGIN" to
		    the LOGIN.COM of all the users on this system who will
		    make use of the network. 

$ INQUIR x "Type <CR> to continue"
$ TYPE SYS$INPUT

	CHNAMES.COM which is called by CHSTART.COM, but which can be invoked
		    at any time to change the system logical names which
		    describe where the various files in the CHAOS kit reside
		    (invoked by CHSTART.COM).


	CHLOADCH.COM and CHLOADPTY.COM which load drivers and IO data-structs
				       (invoked by CHSTART.COM).

	CHRESTART.COM which actually kicks off the NCP (it is invoked by
		      CHSTART.COM).


To start. your network up, just invoke SYS$MANAGER:CHSTART

Once you are satisfied that the startup procedures work correctly, and that
your network is functioning properly, add the line "$ @SYS$MANAGER:CHSTART"
to the file SYS$MANAGER:SYSTARTUP.COM.


End of startup build procedure.

$ set def 'old_dir
$ EXIT 1
$ERROR_EXIT:
$ CLOSE TMP
$ DELETE CHSTART.TMP;
$ set def 'old_dir
$ EXIT
