$ !
$ ! Command file to load and startup CHAOSnet
$ !
$ ! The following privs are needed to execute this command proceedure
$ SET PROC/PRIV=(SYSNAM,CMKRNL,CMEXEC,DETACH,SETPRV,ALTPRI,PSWAPM)
$ !
$ ! Define logical names for where CHAOS software lives.
$ ! The format is @CHNAMES SYSTEM [<sysdev> [<srcdev> [<objdev>]]]
$ ! See CHNAMES.COM for details.
$ @SYS$MANAGER:CHNAMES SYSTEM __DUA0:[CHAOS5REL.]
$ !
$ !
$ ! Define the defaults for the Remote Tape Facility:
$ ! If the name CHAOS$RTAPE_DEFAULTS exists, it has the form
$ !
$ !		"drive/option..."  
$ !
$ ! An option is one of ASSIST, NOASSIST, READ_CHECK, NOREAD_CHECK,
$ ! WRITE_CHECK, or NOWRITE_CHECK.
$ ! The "drive", if present, is the default drive to use if the user does not
$ ! specify one, or if he only specifies a unit number.  If only options are
$ ! present, then there is no default drive and users will have to specify a
$ ! drive with each use of the Remote Tape Facility.
$ DEFINE/SYSTEM CHAOS$RTAPE_DEFAULTS "_MTA0:/NOASSIST/READ_CHECK/WRITE_CHECK" 
$ !
$ !	Load up the pseudo devices used to communicate
$ !	with the NCP and the pseudo terminals
$ !
$ @SYS$MANAGER:CHLOADCH.COM
$ @SYS$MANAGER:CHLOADPTY.COM
$ !
$ RUN SYS$SYSTEM:SYSGEN
LOAD CHAOS$SYSTEM:PCDRIVER
CONNECT PCA0 /ADAP=8/CSR=%O164140/VEC=%O270
EXIT
$ DEFINE/SYS CHNCP$CHAOS0 3043
$ DEFINE/SYS CHNCP$PRIMARY 3043
$ !
$ ! The logical name CHNCP$NOBRIDGE controls whether this node will 
$ ! act as a network bridge, forwarding packets from one subnet to 
$ ! another. Mainly this equates to the broadcasting of routing table
$ ! info.  By default, any node which has more than one interface (as
$ ! defined by the previous logical names) will broadcast routing table
$ ! packets and act as a bridge.  To overide this function, define the
$ ! logical name CHNCP$NOBRIDGE to RESOLVE TO ANYTHING! This is key - the
$ ! NCP only checks for the existence of the logical name in the logical
$ ! name table - the actual equivalence string is ignored (e.g., 
$ ! a) $DEFINE/SYSTEM CHNCP$NOBRIDGE "YES" and
$ ! b) $DEFINE/SYSTEM CHNCP$NOBRIDGE "NO" are equivalent to the NCP, and
$ ! either will disable bridging).
$ !
$ !DEFINE/SYSTEM CHNCP$NOBRIDGE "BRIDGING_OFF" 
$ !
$ !
$ ! Define site's local time zone characteristics:
$ !
$ ! a) GMT_DSP is displacement west of GMT, in delta time format.
$ DEFINE/SYSTEM GMT_DSP  "0 05:00:00.0" 
$ !
$ ! b) DST_SITE should be ON if this site is currently in a time zone
$ !    which is using daylight savings time.  Otherwise it should be OFF 
$ !    or not defined at all.
$ !*************************************************************************
$ !Note: This is a modification from previous releases - the DST_SITE logical
$ !	 should translate to ON ONLY WHEN DAYLIGHT SAVINGS TIME IS ACTUALLY
$ !	 IN EFFECT.  This sacrifice of user-friendliness is due to the 
$ !	 inclusion of the TIME server in the code executed by the NCP, which
$ !	 results in significant performance inprovement - the automatic
$ !	 evaluation of the current state of DST, based on date, may return
$ !	 in a future release. 
$ !*************************************************************************
$ DEFINE/SYSTEM DST_SITE "OFF" 
$ !
$ ! Install software that needs it
$ RUN SYS$SYSTEM:INSTALL
CHAOS$RFC:MAIL/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:NAME/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMEXEC,WORLD,SYSPRV)
CHAOS$RFC:SEND/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:SINK/SHARED/OPEN/HEADER_RESIDENT
CHAOS$RFC:TELNET/SHARED/OPEN/HEADER_RESIDENT/PRIV=(PHY_IO,GROUP,WORLD)
CHAOS$RFC:FILE/SHARED/OPEN/HEADER_RESIDENT/PRIV=(CMKRNL,CMEXEC)
CHAOS$SYSTEM:CHMAIL/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:CFTP/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:QSEND/SHARED/OPEN/HEADER_RESIDENT/PRIV=(SYSPRV,WORLD,OPER)
CHAOS$SYSTEM:STATUS/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:SUPDUP/SHARED/OPEN/HEADER_RESIDENT
CHAOS$SYSTEM:TELUSR/SHARED/OPEN/HEADER_RESIDENT
$!
$!	Now start the NCP process
$!
$ @SYS$MANAGER:CHRESTART
