;;; -*- Mode: LISP; BASE: 10; PACKAGE: CHAOS -*-

(eval-when (eval compile)
	   (or (get 'rmsmdf 'version)
	       (load "nil$disk:[nil.vas]rmsmdf"
		     :binary t
		     :set-default-pathname nil)))
	 
	  
(si:defrmsstruct $iosbdef
  si:$def iosb$l_iosb0
  si:$def iosb$w_io_status
  			si:blkw 1
  si:$def iosb$w_io_count
  			si:blkw 1
  si:$def iosb$l_iosb1
  si:$def iosb$l_param
  			si:blkl 1
  si:$equ iosb$k_iosbmax 8
  si:$equ iosb$c_iosbmax 8)


(si:defrmsstruct $pktdef
  si:$def pkt$b_type si:blkb 1		; MBZ
  si:$def pkt$b_opcode si:blkb 1
;;;  si:$def pkt$w_nbytes               ;this doesn't work, 'cause it's 12 bits
  			si:blkw 1
  si:$def pkt$w_dest_host
  si:$def pkt$b_dest_hostnum si:blkb 1
  si:$def pkt$b_dest_sbn si:blkb 1
  si:$def pkt$w_dest_idx si:blkw 1
  si:$def pkt$w_src_host
  si:$def pkt$b_src_hostnum si:blkb 1
  si:$def pkt$b_src_sbn si:blkb 1
  si:$def pkt$w_src_idx si:blkw 1
  si:$def pkt$w_packet si:blkw 1	; packet number
  si:$def pkt$w_ack si:blkw 1		; acknowledgement

  si:$equ pkt$k_pktmax 504
  si:$equ pkt$c_pktmax 504

  si:$equ pkt$k_rfc 1
  si:$equ pkt$k_opn 2
  si:$equ pkt$k_cls 3
  si:$equ pkt$k_fwd 4
  si:$equ pkt$k_ans 5
  si:$equ pkt$k_sns 6
  si:$equ pkt$k_sts 7
  si:$equ pkt$k_rut 8
  si:$equ pkt$k_los 9
  si:$equ pkt$k_lsn 10
  si:$equ pkt$k_mnt 11
  si:$equ pkt$k_eof 12
  si:$equ pkt$k_data #o200)

(defmacro pkt$w_nbytes (pkt) `(nibble ,pkt 62 12))

(si:defrmsstruct $chandef
  si:$def chan$w_state si:blkw 1	; the state of the channel
  si:$equ chan$k_closed 0
  si:$equ chan$k_rfcrcv 1
  si:$equ chan$k_rfcsnt 2
  si:$equ chan$k_open 3
  si:$equ chan$k_los 4
  si:$equ chan$k_incom 5		; incomplete transmission
  si:$equ chan$k_new 6
  si:$equ chan$k_lsn 7			; listening
  si:$equ chan$k_full #o400		; window is full.

  si:blkw 1				; not used
  si:$def chan$w_xmit_window si:blkl 1	; words so they become fixnums ...
  si:$def chan$w_rcv_window si:blkl 1	; ... rather than bits
  si:$def chan$w_xmit_available si:blkl 1
  si:$def chan$w_rcv_available si:blkl 1

  si:$equ chan$k_chanmax 20
  si:$equ chan$c_chanmax 20)
