;;; -*- Mode:Lisp; Patch-File:Yes; Package:HOST; Base:10 -*-
;;; Random Host table fixes
;;; Written 4/26/83 01:05:44 by PAO
;;; Experimental Chaos 3.1, Experimental Lisp 365.4, VM 982


(defmethod (host-table-part :close) ()
  (when is-open?
    (send file-stream ':disconnect)
    (send rms-file ':close)
    (setq file-stream nil
	  rms-file nil
	  is-open? nil)))


(defmethod (host-table :close-all) ()
  (send nets ':close)
  (send name ':close)
  (send addr ':close)
  (send dial ':close)
  (send host ':close)
  (send rand ':close))


(eval-when (compile eval load)

  (defmacro def-hosttab-op (operation)
      `(progn 'compile
	      (defun ,operation (&restv args)
		(unwind-protect
		 (progn
		  (maybe-init-host-tables)
		  (lexpr-send *the-host-tables* ',(intern operation 'keyword)
			      args))
		 (send *the-host-tables* ':close-all)))
	      (globalize ',operation 'chaos)))

  )

(def-hosttab-op net-number)
(def-hosttab-op host-address)
(def-hosttab-op host-name)
(def-hosttab-op host-info)
