;;; -*- Mode:Lisp; Patch-File:Yes; Package:CHAOS-INTERNALS; Base:10 -*-
;;; connect case dispatch
;;; Written 4/26/83 01:35:09 by PAO
;;; Experimental Chaos 3.3, Experimental Lisp 365.4, VM 982

(defun connect (host contact-name &optional (timeout 5400))
  (let ((new nil)
	state (ok nil))
    (unwind-protect
     (progn
      (setq new (allocate-resource 'connection))
      (setq state
	    (send new ':rfc ':host host ':contact-name contact-name ':timeout timeout))
      (unless state (ferror () "RFC Timeout"))
      (when (not (= state conn$k_open))
	(case state
	  (#.conn$k_closed
	   (if (data-available new)
	       (with-packet (pkt)
		 (send new ':get-packet ':pkt pkt)
		 (case (pkt$b_opcode pkt)
		   (#.pkt$k_cls
		    (ferror () "Connection refused by ~S: ~S"
			    (find-host-name (pkt$w_src_host pkt))
			    (pkt-string pkt)))
		   (#.pkt$k_ans
		    (ferror () "ANS recieved instead of OPN from ~S"
			    (find-host-name (pkt$w_src_host pkt))))))
	       (ferror () "Connection closed by foreign host")))
	  (#.conn$k_los
	   (if (data-available new)
	       (with-packet (pkt)
		 (send new ':get-packet ':pkt pkt)
		 (ferror () "LOS recieved trying to connect to ~S: ~S"
			 (find-host-name (pkt$w_src_host pkt))
			 (pkt-string pkt)))))))
      (setq ok t))
     (unless ok (when new
		  (deallocate-resource 'connection new)
		  (setq new nil))))
    new))
