;;; -*- Mode: LISP; BASE: 10; PACKAGE: CHAOS -*-

(herald pktdefs)

(eval-when (eval compile)
	   (or (get 'si:rmsmdf 'version)
	       (load "nil$disk:[nil.vas]rmsmdf"
		     :binary t
		     :set-default-pathname nil)))
	 
	  
(si:defrmsstruct $iosbdef
  si:$def iosb$l_iosb0
  si:$def iosb$w_io_status
  			si:blkw 1
  si:$def iosb$w_io_count
  			si:blkw 1
  si:$def iosb$l_iosb1
  si:$def iosb$l_param
  			si:blkl 1
  si:$equ iosb$k_iosbmax 8
  si:$equ iosb$c_iosbmax 8)


(si:defrmsstruct $pktdef
  si:$def pkt$b_type si:blkb 1		; MBZ
  si:$def pkt$b_opcode si:blkb 1
;;;  si:$def pkt$w_nbytes               ;this doesn't work, 'cause it's 12 bits
  			si:blkw 1
  si:$def pkt$w_dest_host
  si:$def pkt$b_dest_hostnum si:blkb 1
  si:$def pkt$b_dest_sbn si:blkb 1
  si:$def pkt$w_dest_idx si:blkw 1
  si:$def pkt$w_src_host
  si:$def pkt$b_src_hostnum si:blkb 1
  si:$def pkt$b_src_sbn si:blkb 1
  si:$def pkt$w_src_idx si:blkw 1
  si:$def pkt$w_packet si:blkw 1	; packet number
  si:$def pkt$w_ack si:blkw 1		; acknowledgement

  si:$equ pkt$k_hdrlen 16		; bytes
  si:$equ pkt$k_hdrlen_bits 128		; bits

  si:$equ pkt$k_pktmax 504
  si:$equ pkt$c_pktmax 504

  si:$equ pkt$k_maxdata 488
  si:$equ pkt$c_maxdata 488

  si:$equ pkt$k_rfc 1
  si:$equ rfc-op 1
  si:$equ pkt$k_opn 2
  si:$equ opn-op 2
  si:$equ pkt$k_cls 3
  si:$equ cls-op 3
  si:$equ pkt$k_fwd 4
  si:$equ fwd-op 4
  si:$equ pkt$k_ans 5 
  si:$equ ans-op 5 
  si:$equ pkt$k_sns 6
  si:$equ sns-op 6
  si:$equ pkt$k_sts 7
  si:$equ sts-op 7
  si:$equ pkt$k_rut 8
  si:$equ rut-op 8
  si:$equ pkt$k_los 9
  si:$equ los-op 9
  si:$equ pkt$k_lsn 10
  si:$equ lsn-op 10
  si:$equ pkt$k_mnt 11
  si:$equ mnt-op 11
  si:$equ pkt$k_eof 12
  si:$equ eof-op 12
  si:$equ pkt$k_unc 13
  si:$equ unc-op 13
  si:$equ pkt$k_dat #o200
  si:$equ dat-op #o200
  si:$equ pkt$k_data #o200
  si:$equ data-op #o200
  si:$equ pkt$k_word_data #o300
  si:$equ word-data-op #o300)

(defmacro pkt$w_nbytes (pkt) `(nibble ,pkt 16 12))

(si:defrmsstruct $conndef
  si:$def conn$w_state si:blkw 1	; the state of the connection

  si:$equ conn$k_closed 0
  si:$equ conn$k_rfcrcv 1
  si:$equ conn$k_rfcsnt 2
  si:$equ conn$k_open 3
  si:$equ conn$k_los 4
  si:$equ conn$k_incom 5		; incomplete transmission
  si:$equ conn$k_new 6
  si:$equ conn$k_lsn 7			; listening
  si:$equ conn$k_full #o400		; window is full.

  si:blkw 1				; not used
  si:$def conn$w_xmit_window si:blkl 1	; words so they become fixnums ...
  si:$def conn$w_rcv_window si:blkl 1	; ... rather than bits
  si:$def conn$w_xmit_available si:blkl 1
  si:$def conn$w_rcv_available si:blkl 1

  si:$equ conn$k_connmax 20
  si:$equ conn$c_connmax 20)

(si:defrmsstruct $iodef

  si:$equ io$_readpkt #x21
  si:$equ io$_writepkt #x20
  si:$equ io$_readstatus #x27
  si:$equ io$_readstate #x25)
